Index: CKEditor/trunk/_source/skins/v2/toolbar.css
===================================================================
--- CKEditor/trunk/_source/skins/default/toolbar.css	(revision 3284)
+++ CKEditor/trunk/_source/skins/v2/toolbar.css	(revision 3286)
@@ -12,5 +12,5 @@
 }
 
-.cke_skin_default .cke_toolbar
+.cke_skin_v2 .cke_toolbar
 {
 	padding-top: 1px;
@@ -20,5 +20,5 @@
 }
 
-.cke_skin_default .cke_separator
+.cke_skin_v2 .cke_separator
 {
 	display:inline-block;
@@ -29,11 +29,11 @@
 }
 
-.cke_skin_default .cke_break
+.cke_skin_v2 .cke_break
 {
 	clear:left;
 }
 
-.cke_skin_default .cke_button a,
-.cke_skin_default .cke_button a.cke_off
+.cke_skin_v2 .cke_button a,
+.cke_skin_v2 .cke_button a.cke_off
 {
 	border: solid 1px #efefde;
@@ -53,5 +53,5 @@
 }
 
-.cke_skin_default .cke_button a.cke_on
+.cke_skin_v2 .cke_button a.cke_on
 {
 	border: solid 1px #316ac5;
@@ -61,6 +61,6 @@
 }
 
-.cke_skin_default .cke_button a.cke_disabled,
-.cke_skin_default .cke_browser_ie a:hover.cke_button .cke_disabled
+.cke_skin_v2 .cke_button a.cke_disabled,
+.cke_skin_v2 .cke_browser_ie a:hover.cke_button .cke_disabled
 {
 	border: solid 1px #efefde;
@@ -70,10 +70,10 @@
 }
 
-.cke_skin_default .cke_button a:hover.cke_on,
-.cke_skin_default .cke_button a:focus.cke_on,
-.cke_skin_default .cke_button a:active.cke_on,	/* IE */
-.cke_skin_default .cke_button a:hover.cke_off,
-.cke_skin_default .cke_button a:focus.cke_off,
-.cke_skin_default .cke_button a:active.cke_off	/* IE */
+.cke_skin_v2 .cke_button a:hover.cke_on,
+.cke_skin_v2 .cke_button a:focus.cke_on,
+.cke_skin_v2 .cke_button a:active.cke_on,	/* IE */
+.cke_skin_v2 .cke_button a:hover.cke_off,
+.cke_skin_v2 .cke_button a:focus.cke_off,
+.cke_skin_v2 .cke_button a:active.cke_off	/* IE */
 {
 	border: solid 1px #316ac5;
@@ -83,5 +83,5 @@
 }
 
-.cke_skin_default .cke_button .cke_icon
+.cke_skin_v2 .cke_button .cke_icon
 {
 	background-image: url(icons.png);
@@ -94,5 +94,5 @@
 }
 
-.cke_skin_default .cke_button .cke_label
+.cke_skin_v2 .cke_button .cke_label
 {
 	display: none;
@@ -101,5 +101,5 @@
 }
 
-.cke_skin_default .cke_button .cke_buttonarrow
+.cke_skin_v2 .cke_button .cke_buttonarrow
 {
 	display: inline-block;
@@ -115,14 +115,14 @@
 
 /* Repeat it here for all variations of ".cke_button a" because of IE6 */
-.cke_skin_default .cke_browser_ie .cke_button a,
-.cke_skin_default .cke_browser_ie .cke_button a.cke_off,
-.cke_skin_default .cke_browser_ie .cke_button a.cke_on,
-.cke_skin_default .cke_browser_ie .cke_button a.cke_disabled,
-.cke_skin_default .cke_browser_ie .cke_button a:hover.cke_on,
-.cke_skin_default .cke_browser_ie .cke_button a:focus.cke_on,
-.cke_skin_default .cke_browser_ie .cke_button a:active.cke_on,
-.cke_skin_default .cke_browser_ie .cke_button a:hover.cke_off,
-.cke_skin_default .cke_browser_ie .cke_button a:focus.cke_off,
-.cke_skin_default .cke_browser_ie .cke_button a:active.cke_off
+.cke_skin_v2 .cke_browser_ie .cke_button a,
+.cke_skin_v2 .cke_browser_ie .cke_button a.cke_off,
+.cke_skin_v2 .cke_browser_ie .cke_button a.cke_on,
+.cke_skin_v2 .cke_browser_ie .cke_button a.cke_disabled,
+.cke_skin_v2 .cke_browser_ie .cke_button a:hover.cke_on,
+.cke_skin_v2 .cke_browser_ie .cke_button a:focus.cke_on,
+.cke_skin_v2 .cke_browser_ie .cke_button a:active.cke_on,
+.cke_skin_v2 .cke_browser_ie .cke_button a:hover.cke_off,
+.cke_skin_v2 .cke_browser_ie .cke_button a:focus.cke_off,
+.cke_skin_v2 .cke_browser_ie .cke_button a:active.cke_off
 {
 	padding-top: 2px;
@@ -133,5 +133,5 @@
 }
 
-.cke_skin_default .cke_browser_ie .cke_separator
+.cke_skin_v2 .cke_browser_ie .cke_separator
 {
 	vertical-align: 35%;
@@ -139,5 +139,5 @@
 
 
-.cke_skin_default .cke_browser_ie .cke_button .cke_label
+.cke_skin_v2 .cke_browser_ie .cke_button .cke_label
 {
 	vertical-align: 1px;
@@ -146,14 +146,14 @@
 /* IE+Quirks Section */
 
-.cke_skin_default .cke_browser_iequirks .cke_button a,
-.cke_skin_default .cke_browser_iequirks .cke_button a.cke_off,
-.cke_skin_default .cke_browser_iequirks .cke_button a.cke_on,
-.cke_skin_default .cke_browser_iequirks .cke_button a.cke_disabled,
-.cke_skin_default .cke_browser_iequirks .cke_button a:hover.cke_on,
-.cke_skin_default .cke_browser_iequirks .cke_button a:focus.cke_on,
-.cke_skin_default .cke_browser_iequirks .cke_button a:active.cke_on,
-.cke_skin_default .cke_browser_iequirks .cke_button a:hover.cke_off,
-.cke_skin_default .cke_browser_iequirks .cke_button a:focus.cke_off,
-.cke_skin_default .cke_browser_iequirks .cke_button a:active.cke_off
+.cke_skin_v2 .cke_browser_iequirks .cke_button a,
+.cke_skin_v2 .cke_browser_iequirks .cke_button a.cke_off,
+.cke_skin_v2 .cke_browser_iequirks .cke_button a.cke_on,
+.cke_skin_v2 .cke_browser_iequirks .cke_button a.cke_disabled,
+.cke_skin_v2 .cke_browser_iequirks .cke_button a:hover.cke_on,
+.cke_skin_v2 .cke_browser_iequirks .cke_button a:focus.cke_on,
+.cke_skin_v2 .cke_browser_iequirks .cke_button a:active.cke_on,
+.cke_skin_v2 .cke_browser_iequirks .cke_button a:hover.cke_off,
+.cke_skin_v2 .cke_browser_iequirks .cke_button a:focus.cke_off,
+.cke_skin_v2 .cke_browser_iequirks .cke_button a:active.cke_off
 {
 	padding-bottom: 3px;
@@ -162,9 +162,9 @@
 /* Firefox 2 Section */
 
-.cke_skin_default .cke_browser_gecko .cke_button a,
-.cke_skin_default .cke_browser_gecko .cke_button a.cke_off,
-.cke_skin_default .cke_browser_gecko .cke_button .cke_icon,
-.cke_skin_default .cke_browser_gecko .cke_button .cke_buttonarrow,
-.cke_skin_default .cke_browser_gecko .cke_separator
+.cke_skin_v2 .cke_browser_gecko .cke_button a,
+.cke_skin_v2 .cke_browser_gecko .cke_button a.cke_off,
+.cke_skin_v2 .cke_browser_gecko .cke_button .cke_icon,
+.cke_skin_v2 .cke_browser_gecko .cke_button .cke_buttonarrow,
+.cke_skin_v2 .cke_browser_gecko .cke_separator
 {
 	display: block;
@@ -172,16 +172,16 @@
 }
 
-.cke_skin_default .cke_browser_gecko .cke_button .cke_label,
-.cke_skin_default .cke_browser_gecko .cke_break
+.cke_skin_v2 .cke_browser_gecko .cke_button .cke_label,
+.cke_skin_v2 .cke_browser_gecko .cke_break
 {
 	float: left;
 }
 
-.cke_skin_default .cke_browser_gecko .cke_separator
+.cke_skin_v2 .cke_browser_gecko .cke_separator
 {
 	margin-top: 4px;
 }
 
-.cke_skin_default .cke_browser_gecko .cke_button .cke_label
+.cke_skin_v2 .cke_browser_gecko .cke_button .cke_label
 {
 	padding-top: 3px;